/***********************************************************************
 * Copyright (c)  2017 - 2022, Unicmicro Co.,Ltd .
 * All rights reserved.
 * Filename    : app.c
 * Description : app source file
 * Author(s)   : Mason
 * version     : V1.0
 * Modify date : 2022-08-04
 ***********************************************************************/
#include  "app.h"
#include  "config.h"
#include  "common.h"
#include  "uart0.h"
#include  "uart1.h"
#include  "uart2.h"
#include  "can.h"
#include  "can_protocol.h"

uint32_t g_data_buf[512];

volatile uint8_t rx_flag = 0;
volatile uint8_t can_irq_flag = 0;

extern S_Can_Tx_Msg can_tx_msg;
static uint32_t can_data[4];


#ifdef UART0_COMM
uint8_t uart0_rx_flag = 0;
uint8_t uart0_rx_buf[64];
uint8_t uart0_rx_count = 0;
#endif

#ifdef UART1_COMM
uint8_t uart1_rx_flag = 0;
uint8_t uart1_rx_buf[64];
uint8_t uart1_rx_count = 0;
#endif

#ifdef UART2_COMM
uint8_t uart2_rx_flag = 0;
uint8_t uart2_rx_buf[64];
uint8_t uart2_rx_count = 0;
#endif

#ifdef UART0_COMM
/************************************************************************
 * Function     : uart0_rec_pro
 * Description  : uart0 rec pro 串口接收处理回调函数
 * Input        : none
 * Return       : none
 ************************************************************************/
void uart0_rec_pro(void)
{
	uart0_rx_buf[uart0_rx_count] = uart0_recv_byte();
	uart0_rx_count++;
	uart0_rx_flag = 1;	
}
#endif

#ifdef UART1_COMM
/************************************************************************
 * Function     : uart1_rec_pro
 * Description  : uart1 rec pro 串口接收处理回调函数
 * Input        : none
 * Return       : none
 ************************************************************************/
void uart1_rec_pro(void)
{
	uart1_rx_buf[uart1_rx_count] = uart1_recv_byte();
	uart1_rx_count++;
	uart1_rx_flag = 1;	
}
#endif

#ifdef UART2_COMM
/************************************************************************
 * Function     : uart2_rec_pro
 * Description  : uart2 rec pro 串口接收处理回调函数
 * Input        : none
 * Return       : none
 ************************************************************************/
void uart2_rec_pro(void)
{
	uart2_rx_buf[uart2_rx_count] = uart2_recv_byte();
	uart2_rx_count++;
	uart2_rx_flag = 1;	
}
#endif

/************************************************************************
 * Function     : uart_init
 * Description  : uart_init 串口初始化
 * Input        : none
 * Return       : none
 ************************************************************************/
void uart_init(void)
{
#ifdef  UART0_COMM     
	uart0_rx_flag = 0;
	uart0_init(PCLK, UART0_BAUD_RATE);
	uart0_irq_init(UART0_IRQ_ENABLE, uart0_rec_pro);
#endif

#ifdef  UART1_COMM	
	uart1_rx_flag = 0;	
	uart1_init(PCLK, UART1_BAUD_RATE);
	uart1_irq_init(UART1_IRQ_ENABLE, uart1_rec_pro);
#endif

#ifdef  UART2_COMM    
    uart2_rx_flag = 0;	
	uart2_init(PCLK, UART2_BAUD_RATE);
	uart2_irq_init(UART2_IRQ_ENABLE, uart2_rec_pro);
#endif
}

/************************************************************************
 * Function     : can_irq_pro
 * Description  : can interrupt callback function
 * Input        : none
 * Return       : none
 ************************************************************************/
void can_irq_pro(void)
{
	can_irq_flag = 1;
}

/************************************************************************
 * Function     : can_test
 * Description  : can test
 * Input        : none
 * Return       : none
 ************************************************************************/
void can_test(void)
{
	uint8_t i,j;
	
    printfS("System run at %dHz\r\n", SystemCoreClock);
	printfS("start test CAN tx function! \n");
    
	can_tx_msg.std_id = 0x592;											// 标准ID
	can_tx_msg.ext_id = 0x11E8E477;										// 扩展ID
	
	for(i=0; i<8; i++)
	{
		g_data_buf[i] = i;		    									//CAN发送数据赋值
	}
			
	can_init(CAN_RATE_125K);
	
#ifdef CAN_TX_INT_MODE													//如果中断使能
	can_irq_init(CAN_IRQ_ENABLE, can_irq_pro);
#else
	can_irq_init(CAN_IRQ_DISABLE, can_irq_pro);
#endif
	
	while(1)
	{
		for(j=0; j<8; j++)
		{
			can_tx_msg.data[j] = g_data_buf[j];							//将数据填充到发送消息中 
		}
		can_data_frame(can_data, CAN_IDE_STD_FORMAT, CAN_RTR_DATA, 8);	//帧组包
		can_send_data(can_data);										//帧发送
		
		delay_ms(1000);	
	}
}

/************************************************************************
 * Function     : soc_test
 * Description  : soc test 
 * Input        : none
 * Return       : none
 ************************************************************************/
void soc_test(void)
{
	can_test(); 
 
}
